--/bin/euos
include machine.e
include graphics.e
include get.e
sequence music,pids,ids,go,ready,indx,tm
integer fn,musicProc,readProc,fptype,currentid,curfrq
atom tm2
tick_rate(200)
curfrq=0
currentid=0
tm={}
pids={}
ids={}
go={}
ready={}
indx={}
music={}
function remove(sequence s,integer i)
    if i=1 then
	return s[2..length(s)]
    elsif i=length(s) then
	return s[1..length(s)-1]
    end if
    return s[1..i-1]&s[i+1..length(s)]
end function
function k_getc(integer fn)
    object s
    s=k_read(fn,1)
    if atom(s) then return s end if
    return s[1]
end function
function eof(integer fn)
    if k_getc(fn) != -1 then
	if k_seek(fn,k_tell(fn)-1) then end if
	return 0
    end if
    return 1
end function
function gcid()
    integer i
    i=k_getPid()
    i=ids[find(i,pids)]
    return i
end function
function readData()
    integer i,j,k
    atom len
    currentid=gcid()
    k=find(currentid,ids)
    i=k_getc(fn)
    j=k_getc(fn)
    i=i*#100+j
    if fptype=0 then
	len=float32_to_atom(k_read(fn,4))
    elsif fptype=1 then
	len=float64_to_atom(k_read(fn,8))
    end if
    music[k] = append(music[k],{i,len})
    if eof(fn) then
	if k_close(fn) then end if
	tm &= time()
	go[k]=1
	if k_write(1,sprintf("Muzik ID is %d\n",gcid())) then
	end if
	return musicProc
    else
	return readProc
    end if
end function
function playMusic()
    object rat
    integer i
    currentid=gcid()
    i=find(currentid,ids)
    if go[i]=0 then
	if length(ready)=1 then sound(0) end if
	if k_write(1,sprintf("mID %d has stopped\n",gcid())) then
	end if
	ids=remove(ids,i)
	pids=remove(pids,i)
	go=remove(go,i)
	music=remove(music,i)
	indx=remove(indx,i)
	tm=remove(tm,i)
	ready=remove(ready,i)
	return -1
    end if
    tm2=time()
    if tm2-tm[i] >= music[i][indx[i]][2] then
	tm[i]=time()
	ready[i]=1
    end if
    if curfrq != 0 then
	if music[i][indx[i]][1] != 0 then
	    sound(music[i][indx[i]][1])
	end if
    else
	sound(music[i][indx[i]][1])
    end if
    curfrq=music[i][indx[i]][1]
    if ready[i] then
	indx[i] += 1
	if indx[i] > length(music[i]) then
	    indx[i]=1
	end if
	ready[i]=0
    end if
    return musicProc
end function
function main()
    sequence sig,fil
    integer i,id
    fil=k_getCommandLine()
    if length(fil)=1 then
	if k_write(1,"Usage: /bin/playsnd [sndfile]&\n"&
		     "The & is required or sh will freeze\n") then
	end if return -1
    end if
    fil=fil[2]
    fn=k_open(fil,"rb")
    if fn > -1 then
	sig=k_read(fn,4)
	if not equal(sig,"MUZK") then
	    if k_write(1,'"'&fil&"\" is not a Muzik file\n") then end if
	    return -1
	end if
	go &= 0
	music &= {{}}
	indx &= 1
	i=0
	for j = 1 to length(ids) do
	    if ids[j] > i then
		i=ids[j]
	    end if
	end for
	i += 1
	ids &= i
	pids &= k_getPid()
	ready &= 1
	fptype=k_getc(fn)
	return readProc
    else
	if k_write(1,"Unable to open \""&fil&"\"\n") then end if
	return -1
    end if
end function
readProc=routine_id("readData")
musicProc=routine_id("playMusic")
function stopMusic()
    sequence cmd
    integer i,id
    cmd=k_getCommandLine()
    if length(cmd)=1 then
	if k_write(1,"Usage: /bin/stopsnd ID\n") then
	end if
	return -1
    elsif length(cmd)=2 and equal(cmd[2],"-active") then
	if k_write(1,"Active mIDs are ") then end if
	for j = 1 to length(ids) do
	    if k_write(1,sprintf("%d",ids[j])) then end if
	    if j < length(ids)-1 then
		if k_write(1,", ") then end if
	    elsif j=length(ids)-1 then
		if k_write(1,", and ") then end if
	    end if
	end for
	if k_write(1,"\n") then end if
	return -1
    end if
    if length(cmd) > 1 then
	cmd=value(cmd[2]) id=cmd[2]
	if not find(id,ids) then
	    if k_write(1,sprintf("%d is an invalid ID\n",id)) then end if
	    return -1
	end if
    end if
    i=find(id,ids)
    go[i]=0
    if k_write(1,sprintf("stopping mID %d\n",id)) then
    end if
    return -1
end function
k_addProgram("playsnd",{routine_id("main"),"Muzik Player",1})
k_addProgram("stopsnd",{routine_id("stopMusic"),"Muzic Stopper",1})
