-- IPC: Events by Jeffrey Fielding for EuOS
-- 1.4: OOPS - forgot routines for adding/removing event handlers (FIXED)
sequence k_events
k_events = {}
global function k_eventAlloc()
	integer x
	x = find(-1,k_events)
	if x then
		k_events[x] = {}
		return x
	else
		k_events = append(k_events,{})
		return length(k_events)
	end if
end function
function k_verifyEvent(integer id)
	if id > 0 and id <= length(k_events) then
		if sequence(k_events[id]) then
			return 1
		end if
	end if
	k_setLastError(1,"Invalid event id.")
	return 0
end function
global procedure k_eventDealloc(integer id)
	if k_verifyEvent(id) then
		k_events[id] = -1
	end if
end procedure
global procedure k_fireEvent(integer id, object args)
	if k_verifyEvent(id) then
		for i = 1 to length(k_events[id]) do
			if k_events[id] != -1 then
				call_proc(k_events[id],{id,args})
			end if
		end for
	end if
end procedure
global function k_addEventHandler(integer id, integer routine)
	integer i
	if k_verifyEvent(id) then
		if routine < 0 then
			k_setLastError(2,"Invalid routine_id.")
			return 0
		else
			i = find(-1,k_events[id])
			if i then
				k_events[id][i] = routine
				return i
			else
				k_events[id] &= routine
				return length(k_events[id])
			end if
		end if
	else
		return 0
	end if
end function
global procedure k_removeEventHandler(integer eventid, integer handlerid)
	if k_verifyEvent(eventid) then
		if handlerid > 0 and handlerid <= length(k_events[eventid]) then
			k_events[eventid][handlerid] = -1
		else
			k_setLastError(2,"Invalid handler id.")
		end if
	end if
end procedure
