-- IPC: Messages for EuOS
-- by Jeffrey Fielding (JJProg@cyberbury.net)
sequence k_msgs, k_msg_waiting
k_msgs = {}
k_msg_waiting = {}
global function k_msgAlloc()
	integer index
	index = find(-1,k_msgs)
	if index then
		k_msgs[index] = {}
		return index
	else
		k_msgs = append(k_msgs,{})
		k_msg_waiting = append(k_msg_waiting,{})
		return length(k_msgs)
	end if
end function
global procedure k_msgDealloc(integer id)
	k_msgs[id] = -1
end procedure
global function k_msgGet(integer id)
	object x
	if length(k_msgs[id]) then
		x = k_msgs[id][1]
		k_msgs[id] = k_msgs[id][2..length(k_msgs[id])]
		return x
	else
		return -1
	end if
end function
global function k_msgCheck(integer id)
	return length(k_msgs[id])
end function
global procedure k_msgWait(integer id)
	if length(k_msgs[id]) = 0 then
		k_msg_waiting[id] &= k_getPid()
		k_setPriority(k_getPid(),0)
	end if
end procedure
global procedure k_msgSend(integer id, object msg)
	k_msgs[id] = append(k_msgs[id],msg)
	for i = 1 to length(k_msg_waiting[id]) do
		k_setPriority(k_msg_waiting[id][i],1)
	end for
	k_msg_waiting[id] = {}
end procedure