-- EuOS program initialization
-- by Jeffrey Fielding (JJProg@cyberbury.net)
-- /bin filesystem
global constant K_PROGRAM_MAIN = 1,
		K_PROGRAM_NAME = 2,
		K_PROGRAM_VERSION = 3
sequence k_program_names, k_program_info
sequence k_binfs_fds, k_binfs_pds
integer k_binfs_handler
k_program_names = {}
k_program_info = {}
k_binfs_fds = {}
k_binfs_pds = {}
procedure k_binfs_onmount(sequence dev, sequence root)
	puts(1,"Mounted binfs on " & root & "\n")
end procedure
procedure k_binfs_onunmount(sequence root)
	puts(1,"unmounting " & root & "\n")
end procedure
function k_binfs_close(integer fd)
	k_binfs_fds[find(fd,k_binfs_fds)] = -1
	k_freefd(fd)
	return 0
end function
function k_binfs_read(integer fd, integer n)
	return k_program_info[k_binfs_pds[find(fd,k_binfs_fds)]]
end function
function k_binfs_write(integer fd, object data)
	k_program_info[k_binfs_pds[find(fd,k_binfs_fds)]] = data
	return 0
end function
function k_binfs_seek(integer fd, atom where)
	return 0
end function
function k_binfs_tell(integer fd)
	return 0
end function
function k_binfs_ioctl(integer fd, integer op, object x)
	return 0
end function
function k_binfs_open(sequence file, sequence mode)
	integer fd, i, j
	file = file[6..length(file)]
	j = find(file,k_program_names) 
	if not j then
		k_program_names = append(k_program_names,file)
		k_program_info = append(k_program_info,0)
		j = length(k_program_names)
	end if
	fd = k_allocfd(k_binfs_handler)
	i = find(-1,k_binfs_fds)
	if i then
		k_binfs_fds[i] = fd
		k_binfs_pds[i] = j
	else
		k_binfs_fds &= fd
		k_binfs_pds &= j
	end if
	return fd
end function
function k_binfs_dir(sequence f)
    sequence lst,st
    lst={}
    for i = 1 to length(k_program_names) do
	st=k_program_names[i]
	lst = append(lst,{st,"x",0,0,0,0,0,0,0})
    end for
    return lst
end function
-- FIXME: should actually delete program (that is, remove reference in /bin)?
function k_binfs_del(sequence f)        
	return -1
end function
function k_binfs_mkdir(sequence f)
	return -1
end function
k_binfs_handler = k_new_fd_handler({routine_id("k_binfs_close"),
				    routine_id("k_binfs_read"),
				    routine_id("k_binfs_write"),
				    routine_id("k_binfs_seek"),
				    routine_id("k_binfs_tell"),
				    routine_id("k_binfs_ioctl")})
k_register_fs_type("binfs",{routine_id("k_binfs_open"),
			    routine_id("k_binfs_dir"),
			    routine_id("k_binfs_del"),
			    routine_id("k_binfs_mkdir"),
			    routine_id("k_binfs_onmount"),
			    routine_id("k_binfs_onunmount")})
k_mount("","/bin/","binfs")
global procedure k_addProgram(sequence name, sequence data)
	integer f, junk
	f = k_open("/bin/" & name, "w")
	junk = k_write(f,data)
	junk = k_close(f)
end procedure
include dynincl.e
include wildcard.e
sequence list,dr,tmp
integer fn,j
object ln
list={}
function dir2(sequence path, sequence wildcard)
    sequence d, r, tmp
    if platform() != LINUX then
	wildcard=upper(wildcard)
    end if
    d = dir(path)
    r = {}
    for i = 1 to length(d) do
	tmp=d[i][D_NAME]
	if wildcard_match(wildcard,tmp) then
	    r = append(r,d[i])
	end if
    end for
    return r
end function
dr=dir2("bin","*.e")
if platform() = LINUX then
    for i = 1 to length(dr) do
	dr[i][D_NAME] = "bin/" & dr[i][D_NAME]
    end for
else
    for i = 1 to length(dr) do
	dr[i][D_NAME] = "bin\\" & dr[i][D_NAME]
    end for
end if
if sequence(dir("usr/")) then
    j=length(dr)+1
    tmp=dir("usr/")
    dr &= tmp[3..length(tmp)]
    for i = j to length(dr) do
	dr[i][D_NAME] = "usr\\"&dr[i][D_NAME]
    end for
end if
for i = 1 to length(dr) do
    fn=open(dr[i][D_NAME],"r")
    ln=gets(fn)
    close(fn)
    if sequence(ln) and length(ln) >= 11 and equal(ln[1..11],"--/bin/euos") then
	list &= {dr[i][D_NAME]}
    end if
end for
create_include("_temp.e",list)
include _temp.e
delete_include("_temp.e")
